#include <iostream>
using namespace std;

typedef unsigned long long ullong;
#define min(x,y) (((x)<(y))?(x):(y))

char exp[300000];
ullong cnt = 0;

ullong sum(ullong i) {
	ullong s = 0;
	for( ullong j=1; j<=i; j++ )
		s+= j;
	return s;
}

pair<ullong,ullong> parse(ullong &i) {
	char x = exp[i++];
	if( x == 'V' )
		return pair<ullong,ullong>(1,0);
	else if( x == 'C' ) {
		pair<ullong,ullong> sub = parse(i);
		return pair<ullong,ullong>
			(sub.first, sum(sub.first-1)-sub.second);
	} else if( x == 'U' ) {
		pair<ullong,ullong> a = parse(i),
			b = parse(i);
		return pair<ullong,ullong>
			(a.first+b.first, a.second+b.second);
	}
	cout << "Fatal!" << endl;
	exit(1);
}

int main( int argc, char **argv ) {
	// Read
	char c;
	while( cin.good() ) {
		cnt = 0;
		while( ((c = cin.get()) != '\n') && cin.good()  ) {
			if( (c == 'U') || (c == 'V') || (c == 'C') )
				exp[cnt++] = c;
		}
		if( cin.fail() )
			break;

		ullong i=0;
		pair<ullong,ullong> info = parse(i);
		//cout << info.first << " " << info.second << endl;

		if( info.second == 0 ) {
			cout << info.first << endl;
			continue;
		}

		ullong maxt=1;
		for(; sum(maxt-1) <= info.second; maxt++);
		maxt--;
		if( maxt == info.first ) {
			cout << 0 << endl;
			continue;
		}

		cout << (info.first - maxt) +1 << endl;
	}

	return 0;
}
